/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is SmoothWheel.
 *
 * The Initial Developer of the Original Code is Avi Halachmi.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//SmoothWheel by Avi Halachmi (avihpit@yahoo.com)
//started: 22-Mar-2003 (v0.1)

const WheelScrollIsLinear=true; // selects either linear or non-linear scroll effect
const WheelScrollDuration=250; //max milisec to complete scroll after last wheel event
//reasonable values for WheelScrollDuration are (fast)100/250/500/1000(slow)

const WheelScrollPx=20; //#pixels per scroll line. can i read this value from anywhere???

var wheelScrollLeft; //in pixels
var wheelScrollLeftLastEvent; //in pixels
var wheelScrollEventTimeStamp;
var wheelScrollDeadline;// timestamp
var clientFrame=null;

wheelScrollLeft=0;
wheelScrollLeftLastEvent=0;


//SmoothWheel wheel event handler
function smoothWheelHandler(e){
        e.preventDefault();
        e.stopPropagation();

        wheelScrollEventTimeStamp=(new Date()).getTime();
        wheelScrollDeadline=wheelScrollEventTimeStamp+WheelScrollDuration;
        wheelScrollLeft += WheelScrollPx*(e.detail); //e.detail holds the number of lines to scroll
        wheelScrollLeftLastEvent = wheelScrollLeft;

        var targetDoc = e.target.ownerDocument;
        if (targetDoc.firstChild.id != "main-window") // if we're lost in XUL; Escape!
             clientFrame = targetDoc.defaultView;
        //what should I do if condition is not met??? is it the right condition to test at all??

        window.setTimeout("smoothWheelLoop()",5);
}


//loop to for smooth scrolling the page
function smoothWheelLoop(){
        var toScroll, currentTime, percentageLeft;
        currentTime=(new Date()).getTime();

        if (currentTime >= wheelScrollDeadline) //we're past the deadline. scroll what's left.
                toScroll=wheelScrollLeft;
        else{ // calculate next scroll destination according to scroll profile
                percentageLeft=1.0*(wheelScrollDeadline-currentTime)/WheelScrollDuration;
                toScroll=wheelScrollLeft-scrollProfile(percentageLeft)*wheelScrollLeftLastEvent;
                if ((wheelScrollLeft-toScroll)*wheelScrollLeft < 0) //if going past destination point
                        toScroll=wheelScrollLeft;
        }

        clientFrame.scrollBy(0, toScroll);
        wheelScrollLeft -= toScroll;
        if (wheelScrollLeft==0)
                return;

        window.setTimeout("smoothWheelLoop()",5);
}


//transform percentage left of operation to percentage left according to a scroll profile
function scrollProfile(percentageLeft){
        if (WheelScrollIsLinear)//Linear calculation of next position, return the actual percentage.
                return percentageLeft;

        return percentageLeft*percentageLeft*percentageLeft;  //Non-Linear calculation of next position
}

